/// <reference types="node" />
/// <reference types="node" />
import { IncomingMessage, ServerResponse } from 'http';
import url from 'url';
import Koa from 'koa';
import type { Controller, ControllerContext } from './controller';
import { Config } from './config';
import { SugarServerError } from './error';
export declare function applyApplication(application: Application, req: IncomingMessage, res: ServerResponse): void;
export declare class Application extends Koa<ControllerContext> {
    static isApplication(obj: any): obj is Application;
    static __sugar_Application: boolean;
    static isApplicationClass(objClass: any): objClass is typeof Application;
    static host?: string | {
        includes?: string[];
        excludes?: string[];
    };
    static path?: string | RegExp;
    static rewrite?: (reqUrl: url.UrlWithStringQuery, req: IncomingMessage) => string;
    static Controllers: (typeof Controller)[];
    static Applications: (typeof Application)[];
    static defaultConfig?: any;
    _applyRequest: any;
    config: Config;
    Controllers: (typeof Controller)[];
    constructor();
    onError(err: SugarServerError, ctx: ControllerContext): void;
    useApplication(ApplicationClass: typeof Application): void;
    useController(ControllerClass: typeof Controller): void;
    createContext(req: IncomingMessage, res: ServerResponse): any;
    createApply(): void;
    applyRequest(req: IncomingMessage, res: ServerResponse): any;
}
