import Koa from 'koa';
import type Router from 'koa-router';
import type { Application } from './application';
export declare const ROUTES_KEY: unique symbol;
export type RouteMethod = 'get' | 'post' | 'put' | 'del' | 'all';
export interface RouteConfig {
    key: string;
    method: RouteMethod;
    path: string;
}
export interface ExControllerContext {
    routerPath?: string;
}
export type ControllerContext = ExControllerContext & Koa.Context & Router.RouterContext & {
    app: Application;
};
export declare class Controller {
    static isController(obj: any): obj is Controller;
    static isControllerClass(objClass: any): objClass is typeof Controller;
    static __sugar_Controller: boolean;
    static prefix?: string;
    private [ROUTES_KEY];
    context: ControllerContext;
}
