import 'reflect-metadata';
import type { Controller, ControllerContext } from './controller';
export declare function getter(target: Controller, propertyName: string, descriptor: TypedPropertyDescriptor<(this: Controller, ...args: any[]) => any>): void;
export declare function createParameterGetter(getterCallback: GetterCallback): (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare function config(configKey: string): ((target: Object, propertyKey: string | symbol, parameterIndex: number) => void);
export declare function config(configKey: Object, propertyKey: string | symbol, parameterIndex: number): void;
export declare const Response: (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const NodeResponse: (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const Request: (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const NodeRequest: (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const Context: (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const query: (key: string) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const header: (key: string) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const params: (key: string) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const body: (path?: string) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const bodyJSON: (path?: string) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const bodyFormData: (path?: string) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const bodyText: () => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void;
export declare const cookie: ((...args: Parameters<ControllerContext['cookies']['get']>) => (target: Object, propertyKey: string | symbol, parameterIndex: number) => void);
export interface GetterCallback {
    (ctx: ControllerContext): any;
}
export interface ParameterGetter {
    index: number;
    getter: GetterCallback;
}
