/// <reference types="node" />
/// <reference types="node" />
import { IncomingMessage } from 'http';
import url from 'url';
import Router from 'koa-router';
import type { Application } from './application';
import type { ControllerContext } from './controller';
import { Controller, RouteMethod } from './controller';
/**
 * create routes
 */
export declare const create: (options: {
    method: RouteMethod;
    path: string;
}) => (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function GetRoute(path: string): (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function PostRoute(path: string): (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function PutRoute(path: string): (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function DelRoute(path: string): (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function AllRoute(path: string): (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function getRoutesFromController(controller: Controller): import("./controller").RouteConfig[];
export interface ApplicationMiddlewareConfig {
    application: Application;
    host?: string | {
        includes?: string[];
        excludes?: string[];
    };
    path?: string | RegExp;
    rewrite?: (reqUrl: url.UrlWithStringQuery, req: IncomingMessage) => string;
}
export declare function appendApplication(ApplicationClass: typeof Application): {
    application: Application;
    routerMiddleware: (ctx: ControllerContext, next: () => void) => Promise<void>;
};
export declare function appendControllerToRouter(ControllerClass: typeof Controller): {
    router: Router<any, {}>;
};
