import 'reflect-metadata';
import type { ControllerContext } from './controller';
export declare const required: {
    (target: Object, propertyKey: string | symbol, parameterIndex: number): void;
    validateCallback: ValidateCallback;
};
export declare const string: {
    (target: Object, propertyKey: string | symbol, parameterIndex: number): void;
    validateCallback: ValidateCallback;
};
export declare const number: {
    (target: Object, propertyKey: string | symbol, parameterIndex: number): void;
    validateCallback: ValidateCallback;
};
export declare const array: (itemExtraCheck: ValidateCallback | ParameterValidate) => {
    (target: Object, propertyKey: string | symbol, parameterIndex: number): void;
    validateCallback: ValidateCallback;
};
export declare function validate(target: any, propertyName: string, descriptor: TypedPropertyDescriptor<any>): void;
export declare const validated: (options: ParameterValidate[]) => (target: any, key: string, descriptor?: PropertyDescriptor | undefined) => any;
export declare function createParameterValidate(validateCallback: ValidateCallback): {
    (target: Object, propertyKey: string | symbol, parameterIndex: number): void;
    validateCallback: ValidateCallback;
};
export interface ParameterValidate {
    (target: Object, propertyKey: string | symbol, parameterIndex: number): void;
    validateCallback: ValidateCallback;
}
export interface ValidateCallback {
    (value: any, parameterIndex: number | string, ctx: ControllerContext): void;
}
export interface ParameterValidator {
    index: number;
    validator: ValidateCallback;
}
