"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createThunkClassDecorator = exports.createThunkAttributeDecorator = void 0;
function createThunkAttributeDecorator(callback) {
    return function (options) {
        return function (target, key, descriptor) {
            return mixinDescriptor(callback, options, target, key, descriptor);
        };
    };
}
exports.createThunkAttributeDecorator = createThunkAttributeDecorator;
function createThunkClassDecorator(callback) {
    return function (options) {
        return function (target) {
            return callback(options, target);
        };
    };
}
exports.createThunkClassDecorator = createThunkClassDecorator;
function mixinDescriptor(callback, options, target, key, descriptor) {
    if (!descriptor) {
        descriptor = Object.create(null);
    }
    const newValue = callback.call(target, options, target, key, descriptor);
    if (typeof newValue !== 'undefined') {
        descriptor.value = newValue;
    }
    return descriptor;
}
//# sourceMappingURL=create-thunk-descriptor.js.map